export { PDFDocumentProxy, PDFPageProxy } from 'pdfjs-dist/types/src/pdf';

/*
 * @Author: linminghui linminghui@cloudwalk.com
 * @Date: 2024-05-26 12:02:57
 * @LastEditors: lmh
 * @LastEditTime: 2024-05-30 12:06:54
 * @FilePath: /鼠标应用/ai-h5/src/views/calm-reading/components/utils/types.d.ts
 * @Description: 类型
 */


declare enum IDomEnum {
  ALL = 'whole',
  VIRTUAL = 'virtual',
  SCROLL = 'scroll'
}
type IOptions = {
  container: HTMLElement;
  url: string;
  style?: Partial<IStyle>;
  domMethod?: IDomEnum
  initCallback?: Function
  pdfStateCallback?: Function
}
type IStyle = {
  fill: string;
  stroke: string;
  strokeWidth: string;
  width: string;
  height: string;
}
interface IPDFViewer {
  container: HTMLElement | null;
  setHighlight(chunk_bboxes: ILabelState[]): void;
  get pageState(): IPdfState;
  set pageState(newState: IPdfState);
  destroy(): void;
  prePage(): void;
  jumpPage(num: number): void;
  nextPage(): void;
}
type IPdfState = {
  pageNum: number; // 当前页面
  scale: number; // 缩放比例
  numPages: number; // 总页数
  width: number; // pdf宽度
  height: number; // pdf高度
}

interface CustomCanvasRenderingContext2D extends CanvasRenderingContext2D {
  webkitBackingStorePixelRatio?: number;
  mozBackingStorePixelRatio?: number;
  msBackingStorePixelRatio?: number;
  oBackingStorePixelRatio?: number;
  backingStorePixelRatio?: number;
}

type IChunkBox = number[]

type ILabelState = {
  page: number;
  bbox: IChunkBox
}

type IChunkBoxes = {
  page: number;
  bboxes: IChunkBox[]
}
interface IItemPanel {
  page: number;
  item: HTMLDivElement
}

type IImagePage = {
  width: number;
  height: number;
  src: string;
}

export { type CustomCanvasRenderingContext2D, type IChunkBox, type IChunkBoxes, IDomEnum, type IImagePage, type IItemPanel, type ILabelState, type IOptions, type IPDFViewer, type IPdfState, type IStyle };
